## API Report File for "@cucumber/cucumber"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import { Envelope } from '@cucumber/messages';
import { JsonObject } from 'type-fest';
import { Writable } from 'node:stream';

// @public
export interface IConfiguration {
    backtrace: boolean;
    dryRun: boolean;
    failFast: boolean;
    forceExit: boolean;
    format: Array<string | [string, string?]>;
    formatOptions: JsonObject;
    import: string[];
    language: string;
    loader: string[];
    name: string[];
    order: IPickleOrder;
    parallel: number;
    paths: string[];
    publish: boolean;
    // @deprecated (undocumented)
    publishQuiet: boolean;
    require: string[];
    requireModule: string[];
    retry: number;
    retryTagFilter: string;
    strict: boolean;
    tags: string;
    worldParameters: JsonObject;
}

// @public
export interface ILoadConfigurationOptions {
    file?: string | false;
    profiles?: string[];
    provided?: Partial<IConfiguration> | string[] | string;
}

// @public
export interface ILoadSourcesResult {
    errors: ISourcesError[];
    plan: IPlannedPickle[];
}

// @public
export interface ILoadSupportOptions {
    // (undocumented)
    sources: ISourcesCoordinates;
    // (undocumented)
    support: Partial<ISupportCodeCoordinates>;
}

// @public
export type IPickleOrder = 'defined' | 'random' | `random:${string}`;

// @public
export interface IPlannedPickle {
    // (undocumented)
    location: {
        line: number;
        column?: number;
    };
    name: string;
    // (undocumented)
    uri: string;
}

// @public
export interface IPublishConfig {
    token: string;
    url: string;
}

// @public
export interface IResolvedConfiguration {
    runConfiguration: IRunConfiguration;
    useConfiguration: IConfiguration;
}

// @public
export interface IRunConfiguration {
    // (undocumented)
    formats: IRunOptionsFormats;
    // (undocumented)
    runtime: IRunOptionsRuntime;
    // (undocumented)
    sources: ISourcesCoordinates;
    // (undocumented)
    support: Partial<ISupportCodeCoordinates>;
}

// @public
export interface IRunEnvironment {
    cwd?: string;
    debug?: boolean;
    env?: NodeJS.ProcessEnv;
    stderr?: Writable;
    stdout?: Writable;
}

// @public
export interface IRunOptions {
    // (undocumented)
    formats: IRunOptionsFormats;
    // (undocumented)
    runtime: IRunOptionsRuntime;
    // (undocumented)
    sources: ISourcesCoordinates;
    // (undocumented)
    support: ISupportCodeCoordinatesOrLibrary;
}

// @public
export interface IRunOptionsFormats {
    files: Record<string, string>;
    options: JsonObject;
    publish: IPublishConfig | false;
    stdout: string;
}

// @public
export interface IRunOptionsRuntime {
    dryRun: boolean;
    failFast: boolean;
    filterStacktraces: boolean;
    parallel: number;
    retry: number;
    retryTagFilter: string;
    strict: boolean;
    worldParameters: JsonObject;
}

// @public
export interface IRunResult {
    success: boolean;
    support: ISupportCodeLibrary;
}

// @public
export interface ISourcesCoordinates {
    defaultDialect: string;
    names: string[];
    order: IPickleOrder;
    paths: string[];
    tagExpression: string;
}

// @public
export interface ISourcesError {
    // (undocumented)
    location: {
        line: number;
        column?: number;
    };
    message: string;
    // (undocumented)
    uri: string;
}

// @public
export interface ISupportCodeCoordinates {
    importPaths: string[];
    loaders: string[];
    requireModules: string[];
    requirePaths: string[];
}

// @public
export type ISupportCodeCoordinatesOrLibrary = Partial<ISupportCodeCoordinates> | ISupportCodeLibrary;

// @public
export interface ISupportCodeLibrary {
    // (undocumented)
    readonly originalCoordinates: ISupportCodeCoordinates;
}

// @public
export function loadConfiguration(options?: ILoadConfigurationOptions, environment?: IRunEnvironment): Promise<IResolvedConfiguration>;

// @public
export function loadSources(coordinates: ISourcesCoordinates, environment?: IRunEnvironment): Promise<ILoadSourcesResult>;

// @public
export function loadSupport(options: ILoadSupportOptions, environment?: IRunEnvironment): Promise<ISupportCodeLibrary>;

// @public
export function runCucumber(options: IRunOptions, environment?: IRunEnvironment, onMessage?: (message: Envelope) => void): Promise<IRunResult>;

```
