"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reEscapeTableCell = void 0;
const TEXT = `Feature: Escaped pipes
The \-character will be considered as an escape in table cell
iff it is followed by a |-character, a \-character or an n.

Scenario: They are the future
Given they have arrived
  | \|æ\\n     | \o\no\  |
  | \\\|a\\\\n | ø\\\nø\\|
`;
// re-escape cell antislashes to print cell the way they were written
function reEscapeTableCell(cell) {
    const str = cell.value;
    const line = TEXT.split('\n')[cell.location.line - 1];
    console.log('\n===========\n', line, '\n', line[cell.location.column - 1], '\n', line.substring(cell.location.column - 1, cell.location.column + str.length));
    const out = str
        .replace(/\\/g, '\\\\')
        .replace('|', '\\|')
        .replace(/\n/g, '\\n');
    // console.log(out, cell);
    // // return str;
    return out;
}
exports.reEscapeTableCell = reEscapeTableCell;
