export function splitLongString(text, printWidth) {
    if (printWidth <= 0) {
        return [text];
    }
    // return ['Feature: A very long', 'feature name'];
    const parts = [];
    let previousSpaceIndex = 0;
    let i = 0;
    while (previousSpaceIndex < text.length) {
        // end of text, let's add the last part and exit the loop
        if (previousSpaceIndex + printWidth >= text.length) {
            parts.push(text.substring(previousSpaceIndex));
            break;
        }
        // find the last space of the part
        let lastSpace = text.lastIndexOf(' ', previousSpaceIndex + printWidth);
        // no last space found in the part, let's find the next space
        if (lastSpace === -1 || lastSpace <= previousSpaceIndex) {
            const nextSpace = text.indexOf(' ', previousSpaceIndex + printWidth);
            // no next space found in the part, let's add the part and exit the loop
            if (nextSpace === -1) {
                parts.push(text.substring(previousSpaceIndex));
                break;
            }
            lastSpace = nextSpace;
        }
        const part = text.substring(previousSpaceIndex, lastSpace);
        parts.push(part);
        previousSpaceIndex = lastSpace + 1;
        i++;
    }
    return parts;
    //   // Concatenate parts
    //   const concatenated = parts.join('\n');
    //   return concatenated;
}
